SoVRMLTextureTransform(3)

NAME
SoVRMLTextureTransform - The SoVRMLTextureTransform class defines a transformation applied to texture coordinates.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLTextureTransform.h>

Inherits SoNode.

  Public Member Functions
virtual SoType getTypeId (void) const
SoVRMLTextureTransform (void)
virtual void doAction (SoAction *action)
virtual void callback (SoCallbackAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void pick (SoPickAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoSFVec2f translation
SoSFFloat rotation
SoSFVec2f scale
SoSFVec2f center

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoVRMLTextureTransform ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoVRMLTextureTransform class defines a transformation applied to texture coordinates. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

TextureTransform {
  exposedField SFVec2f center      0 0     # (-inf, inf)
  exposedField SFFloat rotation    0       # (-inf, inf)
  exposedField SFVec2f scale       1 1     # (-inf, inf)
  exposedField SFVec2f translation 0 0     # (-inf, inf)
}

The TextureTransform node defines a 2D transformation that is applied to texture coordinates (see SoVRMLTextureCoordinate). This node affects the way textures coordinates are applied to the geometric surface. The transformation consists of (in order):

•   a translation;

•   a rotation about the centre point;

•   a non-uniform scale about the centre point.

These parameters support changes to the size, orientation, and position of textures on shapes. Note that these operations appear reversed when viewed on the surface of geometry. For example, a scale value of (2 2) will scale the texture coordinates and have the net effect of shrinking the texture size by a factor of 2 (texture coordinates are twice as large and thus cause the texture to repeat). A translation of (0.5 0.0) translates the texture coordinates +.5 units along the S-axis and has the net effect of translating the texture -0.5 along the S-axis on the geometry's surface. A rotation of pi/2 of the texture coordinates results in a -pi/2 rotation of the texture on the geometry.

The center field specifies a translation offset in texture coordinate space about which the rotation and scale fields are applied. The scale field specifies a scaling factor in S and T of the texture coordinates about the center point. scale values shall be in the range (-pi, pi). The rotation field specifies a rotation in radians of the texture coordinates about the center point after the scale has been applied. A positive rotation value makes the texture coordinates rotate counterclockwise about the centre, thereby rotating the appearance of the texture itself clockwise. The translation field specifies a translation of the texture coordinates.

In matrix transformation notation, where Tc is the untransformed texture coordinate, Tc' is the transformed texture coordinate, C (center), T (translation), R (rotation), and S (scale) are the intermediate transformation matrices,

Tc' = -C × S × R × C × T × Tc

Note that this transformation order is the reverse of the Transform node transformation order since the texture coordinates, not the texture, are being transformed (i.e., the texture coordinate system).

Constructor & Destructor Documentation

  SoVRMLTextureTransform::SoVRMLTextureTransform (void)
Constructor.

  SoVRMLTextureTransform::~SoVRMLTextureTransform () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVRMLTextureTransform::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLTextureTransform::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoVRMLTextureTransform::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLTextureTransform::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoVRMLTextureTransform::initClass (void) [static]

  void SoVRMLTextureTransform::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoVRMLTextureTransform::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoVRMLTextureTransform::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoVRMLTextureTransform::getMatrix (SoGetMatrixAction * action) [virtual]
Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

  void SoVRMLTextureTransform::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

Member Data Documentation

  SoSFVec2f SoVRMLTextureTransform::translation
Translation value. Default values is (0, 0, 0).

  SoSFFloat SoVRMLTextureTransform::rotation
Rotation, in radians, around the centre points. Default value is 0.

  SoSFVec2f SoVRMLTextureTransform::scale
Scale vector about the centre point. Default value is (1, 1).

  SoSFVec2f SoVRMLTextureTransform::center
Texture centre. Default value is (0.0, 0.0).

Author

Generated automatically by Doxygen for Coin from the source code.